var def = require('./imports').default;
var THREE = def.THREE;
var Edge = def.Edge;
var Node = def.Node;
var OrbitControls = def.OrbitControls;
var d3 = def.d3;
var ee = def.ee;
var Utils = require('./utils/utils');

module.exports = function (self) {
  self.addNode = function (node) {
    self.graph.addNode(node.id, node.data);
    self.graph.getNode(node.id).x = node.x;
    self.graph.getNode(node.id).y = node.y;
    self.graph.getNode(node.id).fx = node.fx;
    self.graph.getNode(node.id).fy = node.fy;
    self.graph.getNode(node.id).pinned = node.fx != undefined;
    Utils.prepNode(self.graph.getNode(node.id));
    self.drawNode(self.graph.getNode(node.id));
    self.graph.getNode(node.id).links = [];
    self.layoutInit = true;
  };

  self.removeNode = function (node) {
    if (!node || !node.id) {
      return
    }
    self.removeGraphEdges(node)

    self.undrawEdges(node);
    
    self.graph.removeNode(node.id)
    
    self.undrawNode(node);
  }

  self.removeGraphEdges= function(node) {
    var nodeLinks = self.graph.getLinks(node.id);
    if (nodeLinks) {
      nodeLinks.forEach(function(edge) {
        self.graph.removeLink(edge)
      });
    }
  }
  
  self.undrawNode= function(node) {
    var nodes = self.force.nodes();
    if (nodes) {
      for(var i = 0; i < nodes.length; i++) {
        if(nodes[i].id == node.id) {
          self.scene.remove(nodes[i].renderData.draw_object);
          nodes[i].renderData.textHolder.children[0].element.hidden = true;
          nodes.splice(i, 1);
        }
        if(self.nodes.children[i].index == node.id) {
          self.nodes.children.splice(i, 1);
        }
      }
    }
  }
  
  self.undrawEdges = function(node) {
    for (var i = 0; i < self.lineIndices.length; i++) {
      if (self.lineIndices[i].source.id == node.id
        || self.lineIndices[i].target.id == node.id) {
        self.lineIndices[i].hide = true;
      }
    }
  }

  self.getNode = function (node_id) {
    return self.graph.getNode(node_id);
  };
  
  self.addEdge = function (source, target) {
    self.graph.addLink(source.id, target.id);
    self.drawEdge(self.getNode(source.id), self.getNode(target.id));
  };
}